// CustomAttribute.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "CustomAttribute.h"


// This is an example of an exported function.
extern "C" _declspec(dllexport) unsigned char CustomAttribute(unsigned char slider_1, unsigned char slider_2, unsigned char position, AudioInput audio, float* fft )
{
	//FFT resolution: 0 - 255 (11025 Hz)
	//beat 1..4
	//bass 1..6
	//mid  7..119
	//high 120..250
	
	// slider_1  - value 0 - 255 (default: 102 / 40%)
	// slider_2  - value 0 - 50  (default: 5 / 10%)
	// position  - position in list of active attributes
	// return value - value 0 - 255


	// EXAMPLE - Attribute: Volume (freq) 
	// slider 1 - Output Force
	// slider 2 - Backwardness Cutoff

	static float counter = 0;
	static float fix = 0;

	// Warning !!!
	// The static value has conflict with another same attributes in list of active music attributes.
	// You can improve it by using value "position" and dynamic array.


	float  output = ( audio.volume * slider_1 ) / 102;

	if( output > 255 ) 
		output = 255;

	if( output >= fix ) 
	{
		counter = slider_2;  // zpozdeni
		fix = output;
	}

	if( counter > 0)
	{
		output = fix;
		--counter;
	} 
	else
		counter = 0;
	

	return (unsigned char) output; 
}

